[LTP] [PATCH v3 07/10] shell: Add $TST_SKIP_FILESYSTEMS + tests
Petr Vorel
[email protected]
Thu Aug 4 14:19:43 CEST 2022
C API struct tst_test skip_filesystems member equivalent.
Now only running on single filesystem (will be improved in the next
commit)
Signed-off-by: Petr Vorel <[email protected]>
---
New in v3
doc/shell-test-api.txt | 1 +
.../shell/tst_skip_filesystems.sh | 34 +++++++++++++++++++
.../shell/tst_skip_filesystems_skip.sh | 16 +++++++++
testcases/lib/tst_test.sh | 6 ++++
4 files changed, 57 insertions(+)
create mode 100755 lib/newlib_tests/shell/tst_skip_filesystems.sh
create mode 100755 lib/newlib_tests/shell/tst_skip_filesystems_skip.sh
diff --git a/doc/shell-test-api.txt b/doc/shell-test-api.txt
index 65444541e..0961dc5ef 100644
--- a/doc/shell-test-api.txt
+++ b/doc/shell-test-api.txt
@@ -229,6 +229,7 @@ simply by setting right '$TST_FOO'.
| 'TST_NEEDS_KCONFIGS' | Checks kernel kconfigs support for the test (see below).
| 'TST_NEEDS_KCONFIGS_IFS' | Used for splitting '$TST_NEEDS_KCONFIGS' variable,
default value is comma, it only supports single character.
+| 'TST_SKIP_FILESYSTEMS' | Comma separated list of filesystems on which test will be skipped.
| 'TST_TIMEOUT' | Maximum timeout set for the test in sec. Must be int >= 1,
or -1 (special value to disable timeout), default is 300.
Variable is meant be set in tests, not by user.
diff --git a/lib/newlib_tests/shell/tst_skip_filesystems.sh b/lib/newlib_tests/shell/tst_skip_filesystems.sh
new file mode 100755
index 000000000..dd57d6b42
--- /dev/null
+++ b/lib/newlib_tests/shell/tst_skip_filesystems.sh
@@ -0,0 +1,34 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-or-later
+# Copyright (c) 2022 Petr Vorel <[email protected]>
+
+TST_MOUNT_DEVICE=1
+TST_FS_TYPE=ext4
+TST_TESTFUNC=test
+TST_SKIP_FILESYSTEMS="btrfs,ext2,ext3,xfs,vfat,exfat,ntfs,tmpfs"
+TST_CNT=3
+
+test1()
+{
+ EXPECT_PASS "cd $TST_MNTPOINT"
+}
+
+test2()
+{
+ EXPECT_PASS "grep '$TST_MNTPOINT $TST_FS_TYPE' /proc/mounts"
+}
+
+test3()
+{
+ local fs fs_skip
+
+ fs=$(grep "$TST_MNTPOINT $TST_FS_TYPE" /proc/mounts | cut -d ' ' -f3)
+ EXPECT_PASS "[ '$fs' = '$TST_FS_TYPE' ]"
+
+ for fs_skip in $TST_SKIP_FILESYSTEMS; do
+ EXPECT_FAIL "[ $fs = $fs_skip ]"
+ done
+}
+
+. tst_test.sh
+tst_run
diff --git a/lib/newlib_tests/shell/tst_skip_filesystems_skip.sh b/lib/newlib_tests/shell/tst_skip_filesystems_skip.sh
new file mode 100755
index 000000000..0d291a0a0
--- /dev/null
+++ b/lib/newlib_tests/shell/tst_skip_filesystems_skip.sh
@@ -0,0 +1,16 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0-or-later
+# Copyright (c) 2022 Petr Vorel <[email protected]>
+
+TST_MOUNT_DEVICE=1
+TST_FS_TYPE=ext4
+TST_TESTFUNC=test
+TST_SKIP_FILESYSTEMS="ext4"
+
+test()
+{
+ tst_res TFAIL "test should be skipped with TCONF"
+}
+
+. tst_test.sh
+tst_run
diff --git a/testcases/lib/tst_test.sh b/testcases/lib/tst_test.sh
index 3494f7786..926053357 100644
--- a/testcases/lib/tst_test.sh
+++ b/testcases/lib/tst_test.sh
@@ -626,6 +626,7 @@ tst_run()
local _tst_max
local _tst_name
local _tst_pattern='[='\''"} \t\/:`$\;].*'
+ local ret
if [ -n "$TST_TEST_PATH" ]; then
for _tst_i in $(grep '^[^#]*\bTST_' "$TST_TEST_PATH" | sed "s/.*TST_//; s/$_tst_pattern//"); do
@@ -644,6 +645,7 @@ tst_run()
CHECKPOINT_WAIT|CHECKPOINT_WAKE);;
CHECKPOINT_WAKE2|CHECKPOINT_WAKE_AND_WAIT);;
DEV_EXTRA_OPTS|DEV_FS_OPTS|FORMAT_DEVICE|MOUNT_DEVICE);;
+ SKIP_FILESYSTEMS);;
*) tst_res TWARN "Reserved variable TST_$_tst_i used!";;
esac
done
@@ -675,6 +677,10 @@ tst_run()
tst_brk TCONF "test requires kernel $TST_MIN_KVER+"
fi
+ tst_supported_fs -s "$TST_SKIP_FILESYSTEMS" $TST_FS_TYPE
+ ret=$?
+ [ $ret -ne 0 ] && return $ret
+
_tst_setup_timer
[ "$TST_MOUNT_DEVICE" = 1 ] && TST_FORMAT_DEVICE=1
--
2.37.1
More information about the ltp
mailing list